# class Listen::Adapter::TCP

Adapter to receive file system modifications over TCP

### Constants

DEFAULTS
OS_REGEXP
RECEIVE_WINDOW

  Number of bytes to receive at a time

### Attributes

buffer[R]
socket[R]

### Public Class Methods

local_fs?() click to toggle source

    # File lib/listen/adapter/tcp.rb, line 83
    def self.local_fs?
      false
    end

### Public Instance Methods

finalize() click to toggle source

Cleans up buffer and socket

    # File lib/listen/adapter/tcp.rb, line 45
    def finalize
      @buffer = nil
      return unless @socket

      @socket.close
      @socket = nil
    end

handle_data(data) click to toggle source

Buffers incoming data and handles messages accordingly

    # File lib/listen/adapter/tcp.rb, line 64
    def handle_data(data)
      @buffer << data
      while (message = Listen::TCP::Message.from_buffer(@buffer))
        handle_message(message)
      end
    rescue
      _log :error, format('TCP.handle_data crashed: %s:%s', $ERROR_INFO,
                          $ERROR_POSITION * "\n")
      raise
    end

handle_message(message) click to toggle source

Handles incoming message by notifying of path changes

    # File lib/listen/adapter/tcp.rb, line 76
    def handle_message(message)
      type, change, dir, path, _ = message.object
      _log(:debug) { "TCP message: #{[type, change, dir, path].inspect}" }

      _queue_change(type.to_sym, Pathname(dir), path, change: change.to_sym)
    end

run() click to toggle source

Continuously receive and asynchronously handle data

    # File lib/listen/adapter/tcp.rb, line 57
    def run
      while (data = @socket.recv(RECEIVE_WINDOW))
        async.handle_data(data)
      end
    end

start() click to toggle source

Initializes and starts a Celluloid::IO-powered TCP-recipient

    # File lib/listen/adapter/tcp.rb, line 22
    def start
      attempts ||= 3
      _log :info, "TCP: opening socket #{options.host}:#{options.port}"
      @socket = TCPSocket.new(options.host, options.port)
      @buffer = ''
      async.run
    rescue Celluloid::Task::TerminatedError
      _log :debug, "TCP adapter was terminated: #{$ERROR_INFO.inspect}"
    rescue Errno::ECONNREFUSED
      sleep 1
      attempts -= 1
      _log :warn, "TCP.start: #{$ERROR_INFO.inspect}"
      retry if attempts > 0
      _log :error, format('TCP.start: %s:%s', $ERROR_INFO.inspect,
                          $ERROR_POSITION * "\n")
      raise
    rescue
      _log :error, format('TCP.start: %s:%s', $ERROR_INFO.inspect,
                          $ERROR_POSITION * "\n")
      raise
    end